local BlockGravityUpdate = {}
BlockGravityUpdate.__index = BlockGravityUpdate


function BlockGravityUpdate:update(dt)
  self.level.world:foreachEntityWithComponents(function(e)
    local v = e:getComponent("TilePosition")
    local t = e:getComponent("Transform")
    local m = e:getComponent("TileMovement")

    if not m then
      local count = 0
      while not self.level:isFloor(v.pos.x, v.pos.y + 1 + count) do
        count = count + 1
      end

      if count > 0 then
        local c = e:makeComponent("TileMovement", v.pos.x, v.pos.y + count, math.sqrt(8 / count))
        c.ease = "sine_in"
        c.after = function() 
          G.sounds.thud:play()
          for i = 1, 70 do
            local c = math.random(64, 192)
            self.level.particles:spawn(
              t.pos.x+48+math.random(0,32), t.pos.y+64, --p
              math.random(500, 800), math.random(-10, 10), -- v
              0, math.random(-20,-10), -- a
              0,  -- s
              7.5, -- ds
              math.random(1, 10) / 7, -- life
              {10, 0}, -- damping
              c,c,c)

            self.level.particles:spawn(
              t.pos.x+16-math.random(0,32), t.pos.y+64, --p
              math.random(-800, -500), math.random(-10, 10), -- v
              0, math.random(-20,-10), -- a
              0,  -- s
              7.5, -- ds
              math.random(1, 10) / 7, -- life
              {10, 0}, -- damping
              c,c,c)
          end
          self.level:screenshake() end
      end
    end

  end, {"PushableBlock"})
end


local function newBlockGravityUpdate(level)
  local self = {
    level = level
  }

  return setmetatable(self, BlockGravityUpdate)
end


return newBlockGravityUpdate
