local CoinChecker = {}
CoinChecker.__index = CoinChecker


function CoinChecker:update()
  local dw = self.level.world:getEntityByName("dwarf")
  local p = dw:getComponent("TilePosition")
  local m = dw:getComponent("TileMovement")
  local st = dw:getComponent("PlayerState")

  self.level.world:foreachEntityWithComponents(function(e)
    local v = e:getComponent("TilePosition")

    if v.pos.x == p.pos.x and v.pos.y == p.pos.y then
      local sp = dw:getComponent("Sprite")
      local d = st.dir
      st.dir = "dig" .. d
      if d == "r" then
        sp.sprite:play("Dig_R")
      else
        sp.sprite:play("Dig_L")
      end
      G.sounds.pick:play()
      sp.sprite:onEnd(function()
        if d == "r" then
          sp.sprite:play("Dig_Release_R")
          sp.sprite:onEnd( function()
            sp.sprite:play("Idle_R")
            st.dir = "r"
          end)
        else
          sp.sprite:play("Dig_Release_L")
          sp.sprite:onEnd( function()
            sp.sprite:play("Idle_L")
            st.dir = "l"
          end)
        end
        --print(st.dir)
        --e:makeComponent("TileMovement", 10 + self.level.coins, 0, 2)
        local gspr = e:getComponent("Sprite").sprite
        gspr:play("Gold_Explode")
        e:removeComponent("TilePosition")
        local p = e:getComponent("Transform").pos
        p.x = p.x - 32
        p.y = p.y - 36
        gspr:onEnd(function() 
          --self.level.world:killEntity(e)
          e:removeComponent("Sprite")
        end)
        self.level.coins = self.level.coins + 1

        local count = 0
        self.level.world:foreachEntityWithComponents(function(e) count = count + 1 end, "GoldCoin")
        if count == 0 then
          local exit = self.level.world:getEntityByName("exit")
          local spr = exit:getComponent("Sprite")
          G.sounds.exit_open:play()
          spr.sprite:play("Exit_Open")
          spr.sprite:chain("Exit_Glow")
          exit:makeComponent("OpenExit")
        end
     end)
      e:removeComponent("GoldCoin")
    end
  end, {"GoldCoin"})

end


local function newCoinChecker(level)
  local self = {
    level = level
  }

  return setmetatable(self, CoinChecker)
end


return newCoinChecker
