local HintChecker = {}
HintChecker.__index = HintChecker


function HintChecker:update()
  local dw = self.level.world:getEntityByName("dwarf")
  local p = dw:getComponent("TilePosition")
  local m = dw:getComponent("TileMovement")
  local st = dw:getComponent("PlayerState")

  if (st.dir == 'l' or st.dir == 'r') then
    self.level.world:foreachEntityWithComponents(function(e)
      local v = e:getComponent("TilePosition")

      if v.pos.x == p.pos.x and v.pos.y == p.pos.y then
        local hint = e:getComponent("Hint")
        self.level:showHint(hint.title, hint.text)
        self.level.world:killEntity(e)
      end
    end, {"Hint"})
  end

end


local function newHintChecker(level)
  local self = {
    level = level
  }

  return setmetatable(self, HintChecker)
end


return newHintChecker
